#version 430

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout (location = 2) in vec2 uv;

uniform mat4 allTransformsInOnematrix;
uniform mat4 modelMatrix;

out vec3 newNormal;
out vec3 newPosition;
out vec2 uv_out;

void main(){
	gl_Position = allTransformsInOnematrix * vec4(position, 1.0);
	newNormal = normalize(vec3(transpose(inverse(modelMatrix)) * vec4(normal, 0)));
	newPosition = vec3(modelMatrix * vec4(position, 1.0));
	uv_out = uv;
	
}