#version 430

layout (location = 0) in vec3 vertex; 
layout (location = 1) in vec2 uv; 
layout (location = 2) in vec4 posScale; //vec3 position + float scale

uniform mat4 projViewMatrix;
uniform mat4 modelMatrix;

out vec2 uv_out;

mat4 createTransformation(vec3 translation){
	return mat4(1,0,0,0,
                0,1,0,0,
                0,0,1,0,
				translation.x, translation.y, translation.z, 1.0);
}

mat4 createScale(float scale){
	return mat4(scale, 0,0,0,
				0,scale,0,0,
				0,0,scale,0,
				0,0,0,1);
}

void main()
{
    gl_Position = projViewMatrix *createTransformation(vec3(posScale)) * createScale(posScale.w)*  modelMatrix *vec4(vertex, 1.0);
    uv_out = uv;
} 