#version 430

uniform float imageWidthFactor = 1.0/800.0;  // 1/width
uniform float imageHeightFactor = 1.0/450.0; //1/height

float near = 0.1; 
float far  = 150.0;

in vec2 uv_out;

out vec4 color;

uniform sampler2D colorTex;
uniform sampler2D depthColorTex;

void main()
{  	float x = imageWidthFactor;
	float y = imageHeightFactor;
	vec4 horizEdge = vec4( 0.0 );
	horizEdge -= texture2D( colorTex, vec2( uv_out.x - x, uv_out.y - y ) ) * 1.0;
	horizEdge -= texture2D( colorTex, vec2( uv_out.x - x, uv_out.y     ) ) * 2.0;
	horizEdge -= texture2D( colorTex, vec2( uv_out.x - x, uv_out.y + y ) ) * 1.0;
	horizEdge += texture2D( colorTex, vec2( uv_out.x + x, uv_out.y - y ) ) * 1.0;
	horizEdge += texture2D( colorTex, vec2( uv_out.x + x, uv_out.y     ) ) * 2.0;
	horizEdge += texture2D( colorTex, vec2( uv_out.x + x, uv_out.y + y ) ) * 1.0;
	
	vec4 vertEdge = vec4( 0.0 );
	vertEdge -= texture2D( colorTex, vec2( uv_out.x - x, uv_out.y - y ) ) * 1.0;
	vertEdge -= texture2D( colorTex, vec2( uv_out.x    , uv_out.y - y ) ) * 2.0;
	vertEdge -= texture2D( colorTex, vec2( uv_out.x + x, uv_out.y - y ) ) * 1.0;
	vertEdge += texture2D( colorTex, vec2( uv_out.x - x, uv_out.y + y ) ) * 1.0;
	vertEdge += texture2D( colorTex, vec2( uv_out.x    , uv_out.y + y ) ) * 2.0;
	vertEdge += texture2D( colorTex, vec2( uv_out.x + x, uv_out.y + y ) ) * 1.0;
	
	vec3 edge = sqrt((horizEdge.rgb * horizEdge.rgb) + (vertEdge.rgb * vertEdge.rgb));
	
	color = vec4( 0,0,0, floor(max (max (edge.x, edge.y), edge.z)));
}